var reqURL = './playing.php?update=';
var interval, logMax, lastUpdate = 0, timerID, updateTimerID, limitSec = -1, updateLock = false;
var req;
var myDurab, myM, myD, myS, myShield, myMine, myTorpedo, myState, myLimit, isActive = true, timerCell, currentIndex;
var listTbody, logDiv, rankingTbody, updateButton, actionSelect, actionForm, actionFormButton, actionFormCmd, radarApplet;
var isInnerText;

function init(sec, logmax) {
	if (window.ActiveXObject) {
		try {
			req = new ActiveXObject('Msxml2.XMLHTTP');
		} catch (e) {
			try {
				req = new ActiveXObject('Microsoft.XMLHTTP');
			} catch (e2) {
				req = null;
			}
		}
	} else if (window.XMLHttpRequest) {
		req = new XMLHttpRequest();
	} else {
		req = null;
	}
	
	if (!req) {
		alert('お使いのブラウザには対応していません');
		return;
	}
	
	if (document.getElementById('my_durab').innerText) {
		myDurab = document.getElementById('my_durab');
		myM = document.getElementById('my_m');
		myD = document.getElementById('my_d');
		myS = document.getElementById('my_s');
		myShield = document.getElementById('my_shield');
		myMine = document.getElementById('my_mine');
		myTorpedo = document.getElementById('my_torpedo');
		myState = document.getElementById('my_state');
		myLimit = document.getElementById('my_limit');
		isInnerText = true;
	} else {
		myDurab = document.getElementById('my_durab').firstChild;
		myM = document.getElementById('my_m').firstChild;
		myD = document.getElementById('my_d').firstChild;
		myS = document.getElementById('my_s').firstChild;
		myShield = document.getElementById('my_shield').firstChild;
		myMine = document.getElementById('my_mine').firstChild;
		myTorpedo = document.getElementById('my_torpedo').firstChild;
		myState = document.getElementById('my_state').firstChild;
		myLimit = document.getElementById('my_limit').firstChild;
		isInnerText = false;
	}
	listTbody = document.getElementById('list_tbody');
	logDiv = document.getElementById('log_div');
	rankingTbody = document.getElementById('ranking_tbody');
	updateButton = document.getElementById('update_button');
	updateButton.onclick = updateCheck;
	actionForm = document.getElementById('action_form');
	actionForm.onsubmit = actionSubmit;
	actionFormButton = document.getElementById('action_form_button');
	actionSelect = document.getElementById('action_select');
	actionFormCmd = document.getElementById('action_form_cmd');
	radarApplet = document.getElementById('radar');
	
	interval = sec;
	logMax = logmax;
	updateCheck();
	updateTimerID = setInterval('updateCheck()', interval*1000);
}

function actionSubmit() {
	if (updateLock)
		return false;

	if ((actionFormCmd.value == 'attack' && actionSelect.selectedIndex == actionSelect.options.length - 1) || actionFormCmd.value == 'logout') {
		var dd = new Date();
		var time = dd.getTime();
		if (!confirm('ゲームを終了しますか？')) {
			if (limitSec > 0) {
				dd = new Date();
				var sec = Math.ceil((dd.getTime() - time) / 1000);
				if (limitSec - sec < 0)
					limitSec = 0;
				else
					limitSec -= sec;
			}
			return false;
		}
	} else if (actionFormCmd.value == 'move') {
			radarApplet.actionSelected(actionSelect.selectedIndex);
			actionSelect.onchange = null;
	}
	
	actionSelect.disabled = true;
	actionFormButton.disabled = true;
	updateButton.disabled = true;
	
	actionPOST(actionFormCmd.value, actionSelect.options[actionSelect.selectedIndex].value);
	//while (actionSelect.options.length > 0)
	//	actionSelect.remove(0);
	
	return false;
}

function actionPOST(cmd, n) {
	if (!updateLock) {
		updateLock = true;
		
		req.open('POST', reqURL+lastUpdate, true);
		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		req.onreadystatechange = function() {
			if (req.readyState == 4)
				setTimeout('update(req.responseText)', 500);
		}
		req.send('cmd='+cmd+'&action='+n);
		
		//setTimeout('actionPOST("'+cmd+'", '+n+', true)', 300);
	} else {
		setTimeout('actionPOST("'+cmd+'", '+n+')', 500);
	}
}

function updateCheck() {
	if (!updateLock) {
		updateButton.disabled = true;
		
		updateLock = true;
		req.open('GET', reqURL+lastUpdate, true);
		req.onreadystatechange = function() {
			if (req.readyState == 4 && req.status == 200)
				update(req.responseText);
		}
		req.send('');
		//setTimeout('update()', interval * 1000);
	}
}

function update(gameData) {
	parser(gameData);
	
	
	updateLock = false;
	updateButton.disabled = false;
}

function parser(gameData) {
	if (gameData == '0')
		return;
	if (gameData == '' || gameData == '-1') {
		if (updateTimerID)
			clearInterval(updateTimerID);
		if (gameData == '')
			alert('機体が破壊されました');
		location.reload(true);
	}
	
	var lines = gameData.split("\n");
	for (var i = 0; i < lines.length; ++i) {
		if (i == 0) {
			lastUpdate = isNaN(lines[i])? 0: lines[i];
		} else {
			switch (lines[i]) {
			case '2':
				i = updateTurnOrderList(2, i + 1, lines);
				break;
			case '5':
				i = updateStatus(5, i + 1, lines);
				break;
			case '3':
				i = updateGameLog(3, i + 1, lines);
				break;
			case '4':
				i = updateRanking(4, i + 1, lines);
				break;
			}
		}
	}
}

function updateTurnOrderList(type, i, lines) {
	var num;
	var myTopologys = '', otherTopologys = new Array(), otherTopologysKeys = new Array();
	for (num = 0; lines[i] != type; ++i, ++num) {
		var vals = lines[i].split(',');
		if (vals[0] == 1 && vals[4] == 0) {
			if (isInnerText) {
				myDurab.innerText = vals[5];
				myM.innerText = vals[6];
				myD.innerText = vals[7];
				myS.innerText = vals[8];
				if (vals[10] == 0)
					myShield.innerText = 'OFF';
				else if (vals[10] == 1)
					myShield.innerText = 'ON';
				else
					myShield.innerText = 'MAX';
				myMine.innerText = vals[11];
				myTorpedo.innerText = vals[12];
			} else {
				myDurab.nodeValue = vals[5];
				myM.nodeValue = vals[6];
				myD.nodeValue = vals[7];
				myS.nodeValue = vals[8];
				if (vals[10] == 0)
					myShield.nodeValue = 'OFF';
				else if (vals[10] == 1)
					myShield.nodeValue = 'ON';
				else
					myShield.nodeValue = 'MAX';
				myMine.nodeValue = vals[11];
				myTorpedo.nodeValue = vals[12];
			}
		}
		
		var row;
		if (listTbody.rows[num]) {
			row = listTbody.rows[num];
		} else {
			row = listTbody.insertRow(listTbody.rows.length);
			for (var j = 0; j < 7; ++j) {
				row.insertCell(j);
				row.cells[j].innerHTML = '--';
			}
		}
		
		if (isInnerText) {
			row.cells[0].innerText = vals.slice(13).join(',');
			row.cells[1].innerText = vals[5];
			row.cells[2].innerText = vals[6];
			row.cells[3].innerText = vals[7];
			row.cells[4].innerText = vals[8];
			row.cells[5].innerText = vals[9];
			row.cells[6].innerText = '--';
			//timerCell = row.cells[6];
		} else {
			row.cells[0].firstChild.nodeValue = vals.slice(13).join(',');
			row.cells[1].firstChild.nodeValue = vals[5];
			row.cells[2].firstChild.nodeValue = vals[6];
			row.cells[3].firstChild.nodeValue = vals[7];
			row.cells[4].firstChild.nodeValue = vals[8];
			row.cells[5].firstChild.nodeValue = vals[9];
			row.cells[6].firstChild.nodeValue = '--';
			//timerCell = row.cells[6].firstChild;
		}
		row.cells[0].className = 'name';
		var bd = (vals[1]*299+vals[2]*587+vals[3]*114)/1000;
		if (bd > 127)
			bd = parseInt(bd - 125);
		else
			bd = parseInt(bd + 125);
		row.cells[0].style.color = 'rgb('+bd+','+bd+','+bd+')';
		//row.cells[0].style.color = '#000';
		if (vals[4] == 0)
			row.cells[0].style.fontWeight = 'bold';
		else
			row.cells[0].style.fontWeight = 'normal';
		var rgb = vals[1]+','+vals[2]+','+vals[3];
		row.cells[0].style.backgroundColor = 'rgb('+rgb+')';
		
		if (vals[0] == 1) {
			var add = vals[6]+','+vals[7]+','+vals[8]+',';
			if (vals[4] == 0)
				myTopologys = add + myTopologys;
			else
				myTopologys = myTopologys + add;
		} else {
			if (!(rgb in otherTopologysKeys)) {
				otherTopologysKeys[rgb] = otherTopologys.length;
				otherTopologys[otherTopologysKeys[rgb]] = rgb;
			}
			otherTopologys[otherTopologysKeys[rgb]] += ','+vals[4]+','+vals[6]+','+vals[7]+','+vals[8];
			
		}
	}
	radarApplet.updateTopology(myTopologys, otherTopologys.join(':'));
	while (listTbody.rows.length > num)
		listTbody.deleteRow(listTbody.rows.length - 1);
	return i;
}

function updateStatus(type, i, lines) {
	var vals = lines[i].split(',');
	var isMove = false;
	if (vals[0] == 0) {
		var state = '行動順待ち';
		actionFormCmd.value = 'logout';
		isActive = false;
	} else if (vals[0] == 1) {
		var state = '移動行動選択中';
		actionFormCmd.value = 'move';
		isActive = true;
		isMove = true;
	} else {
		var state = '攻撃行動選択中';
		actionFormCmd.value = 'attack';
		isActive = true;
	}
	if (currentIndex != vals[1]) {
		if (listTbody.rows[currentIndex])
			listTbody.rows[currentIndex].className = '';
		currentIndex = vals[1];
		listTbody.rows[currentIndex].className = 'current';
		if (isInnerText)
			timerCell = listTbody.rows[currentIndex].cells[6];
		else
			timerCell = listTbody.rows[currentIndex].cells[6].firstChild;
	}
	if (isInnerText) {
		myState.innerText = state;
		if (!isActive)
			myLimit.innerText = '--';
	} else {
		myState.nodeValue = state;
		if (!isActive)
			myLimit.nodeValue = '--';
	}
	if (vals[2] >= 0) {
		if (timerID)
			clearInterval(timerID);
		limitSec = vals[2];
		limitTimer(false);
		if (limitSec > 0)
			timerID = setInterval('limitTimer(true)', 1000);
	} else {
		if (timerID)
			clearInterval(timerID);
		if (isInnerText)
			timerCell.innerText = '--';
		else
			timerCell.nodeValue = '--';
	}
	while (actionSelect.options.length > 0)
		actionSelect.remove(0);
	if (isActive) {
		var actionTopologys = '', nextTopologys = '';
		if (isMove) {
			var oOpt = document.createElement('option');
			oOpt.text = '';
			oOpt.value = '-1';
			if (document.all)
				actionSelect.add(oOpt, actionSelect.options.length);
			else
				actionSelect.add(oOpt, actionSelect.options.item(actionSelect.options.length));
		}
		for (i += 1; lines[i] != type; ++i) {
			var oOpt = document.createElement('option');
			if (isMove) {
				var vals = lines[i].split(':');
				var act = vals[0].split(',');
				oOpt.text = act[1]+' ['+act[5]+', '+act[6]+', '+act[7]+']';
				oOpt.value = act[0];
				actionTopologys += act[2]+','+act[3]+','+act[4]+"\n";
				nextTopologys += vals[1]+"\n";
			} else {
				var act = lines[i].split(',');
				oOpt.text = act[1];
				oOpt.value = act[0];
			}
			if (document.all)
				actionSelect.add(oOpt, actionSelect.options.length);
			else
				actionSelect.add(oOpt, actionSelect.options.item(actionSelect.options.length));
		}
	} else {
		var oOpt = document.createElement('option');
		oOpt.text = '離脱';
		oOpt.value = 1;
		if (document.all)
			actionSelect.add(oOpt, actionSelect.options.length);
		else
			actionSelect.add(oOpt, actionSelect.options.item(actionSelect.options.length));
		while (lines[i] != type)
			++i;
	}
	if (isMove) {
		radarApplet.setActionTopologys(actionTopologys, nextTopologys);
		actionSelect.onchange = moveActionChange;
		actionFormButton.disabled = true;
	} else {
		actionSelect.onchange = null;
		actionFormButton.disabled = false;
	}
	actionSelect.disabled = false;
	
	//setTimeout('formEnabled()', 300);
	return i;
}

function moveActionChange() {
	if (this.selectedIndex == 0)
		actionFormButton.disabled = true;
	else
		actionFormButton.disabled = false;
	radarApplet.actionChange(this.selectedIndex);
}

function formEnabled() {
	actionSelect.disabled = false;
	actionFormButton.disabled = false;
}

function updateRanking(type, i, lines) {
	for (; lines[i] != type; ++i) {
		var vals = lines[i].split(',');
		
		var row;
		if (rankingTbody.rows[num]) {
			row = rankingTbody.rows[num];
		} else {
			row = rankingTbody.insertRow(rankingTbody.rows.length);
			for (var j = 0; j < 2; ++j) {
				row.insertCell(j);
				row.cells[j].innerHTML = '--';
			}
		}
		
		
		if (isInnerText) {
			row.cells[0].innerText = vals[0];
			row.cells[1].innerText = vals.slice(1).join(',');
		} else {
			row.cells[0].firstChild.nodeValue = vals[0];
			row.cells[1].firstChild.nodeValue = vals.slice(1).join(',');
		}
	}
	while (rankingTbody.rows.length > num)
		rankingTbody.deleteRow(rankingTbody.rows.length - 1);
	return i;
}

function updateGameLog(type, i, lines) {
	if (document.all) {
		for (; lines[i] != type; ++i) {
			logDiv.insertAdjacentHTML('afterBegin', '<div>'+lines[i]+'</div>');
		}
		while (logDiv.children.length > logMax)
			logDiv.removeChild(logDiv.children[logDiv.children.length - 1]);
	} else {
		for (; lines[i] != type; ++i) {
			var oDiv = document.createElement('div');
			oDiv.innerHTML = lines[i];
			logDiv.insertBefore(oDiv, logDiv.firstChild);
		}
		while (logDiv.childNodes.length > logMax)
			logDiv.removeChild(logDiv.lastChild);
	}
	return i;
}

function limitTimer(t) {
	if (isInnerText) {
		if (isActive)
			myLimit.innerText = limitSec;
		timerCell.innerText = limitSec;
	} else {
		if (isActive)
			myLimit.nodeValue = limitSec;
		timerCell.nodeValue = limitSec;
	}
	
	if (--limitSec < 0 && timerID && t)
		clearInterval(timerID);
}

function loginForm(page, cMin, cMax) {
	var check;
	document.open();
	if (window.ActiveXObject) {
		try {
			check = new ActiveXObject('Msxml2.XMLHTTP');
		} catch (e) {
			try {
				check = new ActiveXObject('Microsoft.XMLHTTP');
			} catch (e2) {
				check = null;
			}
		}
	} else if (window.XMLHttpRequest) {
		check = new XMLHttpRequest();
	} else {
		check = null;
	}
	if (check) {
		document.writeln('<form action="'+page+'" method="post" id="login_form" onsubmit="return login();"><div>');
		document.writeln('<input type="hidden" name="cmd" value="login">');
		document.writeln('<input type="hidden" name="name" value="" id="login_name">');
		document.writeln('<input type="hidden" name="color" value="" id="login_color">');
		document.writeln('<div><applet width="500" height="45" code="kenran.LoginForm" codebase="./" archive="kenran.jar" id="name_input">');
		document.writeln('<param name="color_min" value="'+cMin+'">');
		document.writeln('<param name="color_max" value="'+cMax+'">');
		document.writeln('<div class="message">ゲームへの参加には<a href="http://www.java.com/">Java</a>とJavaScriptを有効にする必要があります</div>');
		document.writeln('</applet></div>');
		document.writeln('<div><input type="submit" value="ゲームに参加" class="button" id="login_button"></div>');
		document.writeln('</div></form>');
		window.onload = javaCheck;
	} else {
		document.writeln('<div class="message">お使いのブラウザには対応していません</div>');
	}
	document.close();
}

function javaCheck() {
	var nameInputField = document.getElementById('name_input');
	var loginForm = document.getElementById('login_form');
	if (!nameInputField.isJava) {
		var loginBtn = document.getElementById('login_button');
		loginBtn.disabled = true;
		loginBtn.style.display = 'none';
	}
}

function login() {
	var nameInputField = document.getElementById('name_input');
	var inputedName = nameInputField.getInputedName();
	if (inputedName == '') {
		alert('名前を入力してください');
		return false;
	} else {
		var loginName = document.getElementById('login_name');
		loginName.value = inputedName;
		var loginColor = document.getElementById('login_color');
		loginColor.value = nameInputField.getInputedColor();
		return true;
	}
}